/**
 * DragDropAnnotate
 * https://github.com/AntoninoBonanno/DragDropAnnotate
 * @author Bonanno Antonino 
 * 
 * jQuery plugin to annotate images easily with drag and drop.
 * DragDropAnnotate is a lightweight image annotation tool that make it easy to add custom markers, comments, hotspots to images via drag and drop.
 * Supports rectangle, and image annotations. The drag and drop functionality based on jQuery UI draggable widget.
 */
"use strict";!function(t){var e="onMouseMoveOverItem",o="onAnnotationRemoved",n="onAnnotationCreated",i="onAnnotationUpdated",a="disabled",r="noText",s="full",d=!1,h=!1;function c(t){return{x:t.x,y:t.y}}function l(t){var e=t.changedTouches[0];h=!0;var o=document.createEvent("MouseEvent");if(o.initMouseEvent({touchstart:"mousedown",touchmove:"mousemove",touchend:"mouseup"}[t.type],!0,!0,window,1,e.screenX,e.screenY,e.clientX,e.clientY,!1,!1,!1,!1,0,null),e.target.dispatchEvent(o),d){t.preventDefault();var n=document.elementFromPoint(e.clientX,e.clientY);n instanceof HTMLCanvasElement&&n.dispatchEvent(o)}}document.addEventListener("touchstart",l,{passive:!1}),document.addEventListener("touchmove",l,{passive:!1}),document.addEventListener("touchend",l,{passive:!1}),document.addEventListener("touchcancel",l,{passive:!1});var u=function(t,e=50,o=50,n=0){this.center=t,this.width=e,this.height=o,this.rotation=n,this.area=e*o;var i=void 0,a=this,r=function(){var t=a.rotation*Math.PI/180,e=Math.sin(t),o=Math.cos(t),n=a.width/2,r=a.height/2,s=n*o,d=r*e,h=n*e,c=r*o;(i={}).topR={x:a.center.x+s-d,y:a.center.y-h-c},i.topL={x:a.center.x-s-d,y:a.center.y+h-c},i.botL={x:a.center.x-s+d,y:a.center.y+h+c},i.botR={x:a.center.x+s+d,y:a.center.y-h+c}};this.intersect=function(t,e){i||r();var o=Math.abs(t*i.topL.y-i.topL.x*e+(i.botR.x*e-t*i.botR.y)+(i.topL.x*i.botR.y-i.botR.x*i.topL.y))/2;return o+=Math.abs(t*i.botR.y-i.botR.x*e+(i.botL.x*e-t*i.botL.y)+(i.botR.x*i.botL.y-i.botL.x*i.botR.y))/2,o+=Math.abs(t*i.botL.y-i.botL.x*e+(i.topR.x*e-t*i.topR.y)+(i.botL.x*i.topR.y-i.topR.x*i.botL.y))/2,(o+=Math.abs(t*i.topR.y-i.topR.x*e+(i.topL.x*e-t*i.topL.y)+(i.topR.x*i.topL.y-i.topL.x*i.topR.y))/2)<=a.area},this.getLowerVertex=function(){return i||r(),i.lowerVertex||(i.lowerVertex={x:i.botL.x,y:i.botL.y},Object.keys(i).forEach(t=>{i.lowerVertex.y<i[t].y&&(i.lowerVertex={x:i[t].x,y:i[t].y})})),i.lowerVertex},this.update=function(t,e){if(t&&(a.center=t),e){for(;e>360;)e-=360;a.rotation=e}i=void 0},this.print=function(){return i||r(),{position:{center:c(a.center),topL:c(i.topL),topR:c(i.topR),botL:c(i.botL),botR:c(i.botR)},rotation:a.rotation,width:e,height:o}}},p=function(t,e,o,n,i=r){this.id=t,this.text=o,e instanceof Image&&(this.image=e),this.geometry=n,this.editable=i,this.created_at=Date.now();var a=this;this.print=function(){return{id:a.id,image:a.image?a.image.src:void 0,text:a.text,...a.geometry.print(),editable:a.editable,created_at:a.created_at}},this.isEqualPrint=function(t){return!(!t instanceof Object)&&t.created_at==a.created_at}},f=function(e,o){if(o.hint.enabled){var n=t('<div class="dda-hint-msg dda-opacity-fade" style="opacity: 0;">'+o.hint.message+"</div>"),i=t('<div class="dda-hint-icon">'+o.hint.icon+"</div>"),a=t('<div class="dda-hint"></div>');a.append(n),a.append(i),e.append(a);var r=void 0,s=this;i.mouseover(()=>{s.show()}),i.mouseout(()=>{s.hide()}),t(o.draggable).mouseover(()=>{s.show()}),this.show=function(t,e){clearTimeout(r),t&&i.html(t),e&&n.html(e),n.css("opacity",1),r=setTimeout(()=>{s.hide()},3e3)},this.hide=function(){clearTimeout(r),n.css("opacity",0),n.html(o.hint.message),i.html(o.hint.icon)}}},g=function(e,o,n){var i=t('<div class="dda-popup-buttons"></div>'),r=t('<button role="button" class="dda-popup-button-rotate" data-toggle="tooltip" title="'+n.popup.tooltipRotate+'">'+n.popup.buttonRotate+"</button>"),d=t('<button role="button" class="dda-popup-button-remove" data-toggle="tooltip" title="'+n.popup.tooltipRemove+'">'+n.popup.buttonRemove+"</button>");i.append(r),i.append(d);var c=t('<div class="dda-popup"></div>').hide(),l=t('<textarea type="text" class="dda-popup-textarea" data-toggle="tooltip" title="'+n.popup.tooltipTextarea+'" placeholder = "'+n.popup.placeholderTextarea+'"></textarea>'),u=t('<div class="dda-popup-text" data-toggle="tooltip" title="'+n.popup.tooltipText+'"></div>');c.append(t("<div></div>").append(l)),c.append(u),c.append(i),o.append(c);var p=!1,f=void 0,g=this;c.mouseover(t=>p=!0),c.mouseout(t=>p=!1),r.click(t=>{e.startRotateAnnotation(f)}),d.click(t=>{e.removeAnnotation(f)}),l.keyup(t=>{e.editTextAnnotation(f,l.val())}),this.show=function(t,e){(f=t).text?u.show().html(f.text):u.hide(),f.editable==s?(u.hide(),l.show().prop("disabled",!1).removeAttr("style").val(f.text)):l.hide().prop("disabled",!0),f.editable!=a?i.show():i.hide(),c.css({top:e.y,left:e.x}).show()},this.hide=function(t=!1){if(!g.isHidden()&&(h||!p||t))var e=setTimeout(()=>{(h||!p||t)&&(f=void 0,c.hide()),clearTimeout(e)},300)},this.isHidden=function(){return c.is(":hidden")}},v=function(r,l,v){var m=t('<canvas class="dda-canvas"></canvas>');r.append(m);var y=new g(this,r,l),b=new f(r,l),x=[],w=void 0,A=void 0,R=void 0,L=m[0].getContext("2d"),M=this;m.droppable({drop:function(t,e){A.geometry.update(E(e.offset.left,e.offset.top)),M.addAnnotation(A),A=void 0},over:function(t,e){e.helper.is(":hidden")||e.helper.hide(),A=new p(e.draggable.attr("annotation-id"),e.draggable[0],e.draggable.attr("annotation-text"),new u(E(e.offset.left,e.offset.top),e.draggable.attr("annotation-width")||e.draggable[0].naturalWidth,e.draggable.attr("annotation-height")||e.draggable[0].naturalHeight,e.draggable.attr("annotation-rotation")),e.draggable.attr("annotation-editable"))},out:function(t,e){e.helper.is(":hidden")&&e.helper.show(),A=void 0,M.redrawAnnotations()}}),m.mousemove(t=>{var o=T(t.offsetX,t.offsetY);if(v(e,c(o)),A)return M.redrawAnnotations(),A.geometry.update(o),void S(A);if(w)w(o);else{var n=k(o);if(0==n.length)return R=n=void 0,m.css("cursor","default"),y.hide(),void M.redrawAnnotations();(y.isHidden()||R!=n[0])&&(R!=n[0]&&(R=n[0],b.show&&b.show(l.hint.iconMove,l.hint.messageMove),m.css("cursor","move"),M.redrawAnnotations(R)),y.show(R,I()))}}),m.mouseup(t=>{if(w){var e=w();v(i,[e.new.print(),e.old_print]),w=void 0}d=!1}),m.mousedown(t=>{if(h&&!d&&(d=!0,t.type="mousemove",m.trigger(t)),R&&!w){h||y.hide(!0);var e=R.print(),o=T(t.offsetX,t.offsetY);o={x:o.x-R.geometry.center.x,y:o.y-R.geometry.center.y},w=function(t){if(t){var n={x:t.x-o.x,y:t.y-o.y};h&&n.x!=R.geometry.center.x&&n.y!=R.geometry.center.y&&y.hide(),R.geometry.update({x:n.x,y:n.y}),M.redrawAnnotations(R)}return{new:R,old_print:e}}}});var T=function(t,e){return{x:parseInt(t/m.width()*m[0].width),y:parseInt(e/m.height()*m[0].height)}},E=function(t,e){return T(t-m.offset().left,e-m.offset().top)},I=function(){if(R){var t,e,o=R.geometry.getLowerVertex();return t=o.x,e=o.y,{x:parseInt(t*m.width()/m[0].width),y:parseInt(e*m.height()/m[0].height)}}},S=function(t,e=!1){var o,n,i=-t.geometry.width/2,a=-t.geometry.height/2;(L.save(),L.beginPath(),L.translate(t.geometry.center.x,t.geometry.center.y),L.rotate(-t.geometry.rotation*Math.PI/180),t.image&&L.drawImage(t.image,i,a,t.geometry.width,t.geometry.height),!t.image||l.annotationStyle.imageBorder)&&(e?(n=l.annotationStyle.hiBorderColor,o=l.annotationStyle.hiBorderSize):(n=l.annotationStyle.borderColor,o=l.annotationStyle.borderSize),L.lineJoin="round",L.lineWidth=1,L.strokeStyle="#000000",L.strokeRect(i+.5,a+.5,t.geometry.width-1,t.geometry.height-1),L.lineJoin="miter",L.lineWidth=o,L.strokeStyle=n,L.strokeRect(i+1+o/2,a+1+o/2,t.geometry.width-2-o,t.geometry.height-2-o));L.restore()},k=function(t){var e=[];return x.forEach(o=>{o.geometry.intersect(t.x,t.y)&&e.push(o)}),e=e.reverse()};this.resize=function(t,e){m[0].width=t,m[0].height=e},this.clear=function(){L.clearRect(0,0,m[0].width,m[0].height)},this.redrawAnnotations=function(t){M.clear();var e=void 0;x.forEach(o=>{var n=!!t&&(t instanceof Object?o==t:o.id===t);if(n&&l.annotationStyle.foreground)return e&&S(e,!0),void(e=o);S(o,n)}),e&&S(e,!0)},this.getAnnotations=function(){return x},this.addAnnotation=function(t,e,o=!0){if(e){var i=x.indexOf(e);i>-1&&(x[i]=t,M.redrawAnnotations())}else{var a=!0;for(let e=0;e<x.length;e++){if(x[e].geometry.area<t.geometry.area){x.splice(e,0,t),a=!1;break}}a&&x.push(t),S(t),o&&v(n,[t.print()])}},this.startRotateAnnotation=function(t){if(t.editable!=a){y.hide(!0),b.show&&b.show(l.hint.iconRotate,l.hint.messageRotate),m.css("cursor","default");var e,o=t.print();w=function(n){if(n){var i=180*Math.atan2(n.y-t.geometry.center.y,n.x-t.geometry.center.x)/Math.PI;t.geometry.update(void 0,t.geometry.rotation+(e-i)),e=i,M.redrawAnnotations(t)}return{new:t,old_print:o}}}},this.removeAnnotation=function(t,e=!0){t.editable!=a&&(y.hide(!0),x.splice(x.indexOf(t),1),e&&v(o,[t.print()]),M.redrawAnnotations())},this.removeAll=function(t){if(t)return x=x.filter(e=>e.id!==t),void M.redrawAnnotations();x=[],M.clear()},this.editTextAnnotation=function(t,e,o=!0){if(t.editable==s){var n=t.print();t.text=e,o&&v(i,[t.print(),n])}}},m=function(e,o){this.image=e instanceof t?e:t(e),!this.image[0]instanceof Image&&t.error("Annotable it must be an image."),this.image.wrap(t('<div class="dda-annotationlayer"></div>'));var n=this,i=new v(this.image.parent(),o,function(t,e){n.image.trigger(t,e)});this.image[0].complete?i.resize(this.image[0].naturalWidth,this.image[0].naturalHeight):this.image[0].onload=function(){i.resize(this.naturalWidth,this.naturalHeight)};var a=function(t,e,o){var n=o?r(o):void 0;i.addAnnotation(new p(t.id,e,t.text,new u(t.position.center,t.width||e.naturalWidth,t.height||e.naturalHeight,t.rotation),t.editable),n,!1)},r=function(e){var o=i.getAnnotations().find(t=>t.isEqualPrint(e));return o||t.error("Annotation not found."),o};this.addAnnotation=function(e,o){if(e.position&&e.position.center&&e.position.center.x&&e.position.center.y||t.error("Invalid annotation."),e.image)if(e.image instanceof Image)a(e,e.image,o);else{(!e.image instanceof String||!e.image.includes("http"))&&t.error("Image must be a URL or an instance of Image.");var n=new Image;n.src=e.image,n.onload=function(){a(e,this,o)}}else a(e,{},o)},this.getAnnotations=function(){var t=[];return i.getAnnotations().forEach(e=>{t.push(e.print())}),t},this.removeAnnotation=function(t){i.removeAnnotation(r(t),!1)},this.removeAll=function(t){i.removeAll(t)},this.hideAnnotations=function(){i.clear()},this.showAnnotations=function(){i.redrawAnnotations()},this.highlightAnnotation=function(t){i.redrawAnnotations(t instanceof Object?r(t):t)},this.on=function(t,e){this.image.on(t,e)}};t.fn.annotable=function(e){if("object"==typeof e||!e){var o=t.extend(!0,{},t.fn.annotable.defaults,e),n=this.length>1?[]:void 0;t(o.draggable).is(":ui-draggable")||t(o.draggable).draggable({helper:"clone",ghosting:!0,cursorAt:{top:0,left:0},revert:"invalid",start:function(){d=!0},stop:function(){d=!1}})}var i=Array.prototype.slice.call(arguments,1);return this.each(function(){var a=t(this),r=a.data("annotable");if(r){if("string"==typeof e&&r[e])return r[e].apply(r,i);t.error("Method "+e+" does not exist on Annotable")}else o?(r=new m(this,o),a.data("annotable",r),n?n.push(r):n=r):t.error("Annotable is not initialized.")}),n},t.fn.annotable.defaults={draggable:".draggable-annotation",hint:{enabled:!0,message:"Drag and Drop to Annotate",icon:'<i class="far fa-question-circle"></i>',messageMove:"Drag to set new annotation position",iconMove:'<i class="fas fa-info"></i>',messageRotate:"Move to set new annotation rotation",iconRotate:'<i class="fas fa-info"></i>'},popup:{buttonRotate:'<i class="fas fa-sync-alt"></i>',tooltipRotate:"Change the rotation of annotation",buttonRemove:'<i class="fas fa-trash"></i>',tooltipRemove:"Remove the annotation",tooltipText:"Text of annotation",tooltipTextarea:"Text of annotation",placeholderTextarea:"Enter Text"},annotationStyle:{borderColor:"#ffffff",borderSize:2,hiBorderColor:"#fff000",hiBorderSize:2.2,imageBorder:!0,foreground:!0}}}(jQuery);